apt-helper crashed with SIGABRT in __gnu_cxx::__verbose_terminate_handler()

Bug #1538438 reported by Christopher M. Penalver on 2016-01-27
136
This bug affects 22 people
Affects Status Importance Assigned to Milestone
apt (Ubuntu)
High
Unassigned
Xenial
High
Brian Murray

Bug Description

Test Case
----------
Given that there are thousands of these crashes in the Error Tracker, just make sure the new version doesn't appear there.

Errors Bucket
-------------
https://errors.ubuntu.com/bucket/?id=/usr/lib/apt/apt-helper%3A6%3A__gnu_cxx%3A%3A__verbose_terminate_handler%3A__cxxabiv1%3A%3A__terminate%3Astd%3A%3Aterminate%3A__cxxabiv1%3A%3A__cxa_throw%3Astd%3A%3A__throw_out_of_range_fmt

Original Description
--------------------
After installing flashplugin-installer I get a prompt noting:
[START]
Failure to download extra data files

The following packages requested additional data downloads after package installation, but the data could not be downloaded or could not be processed.

flashplugin-installer

The download will be attempted again later, or you can try the download again now. Running this command requires an active Internet connection.
[END]

Clicking the button Run this action now causes this crash consistently.

Unfortunately, this has the negative outcome of disallowing folks who use Firefox from being able to update, or install Flash.

There are a fair number of these events logged in errors.ubuntu.com.

ProblemType: CrashDistroRelease: Ubuntu 16.04
Package: apt 1.1.10
ProcVersionSignature: Ubuntu 4.3.0-7.18-generic 4.3.3
Uname: Linux 4.3.0-7-generic x86_64
ApportVersion: 2.19.4-0ubuntu1
Architecture: amd64
Date: Wed Jan 27 01:36:34 2016
ExecutablePath: /usr/lib/apt/apt-helper
InstallationDate: Installed on 2015-04-25 (276 days ago)
InstallationMedia: Ubuntu 15.04 "Vivid Vervet" - Release amd64 (20150422)
ProcCmdline: /usr/lib/apt/apt-helper download-file http://archive.canonical.com/pool/partner/a/adobe-flashplugin/adobe-flashplugin_20151228.1.orig.tar.gz /var/lib/update-notifier/package-data-downloads/partial/adobe-flashplugin_20151228.1.orig.tar.gz SHA256:d322547d4542eeed2f57469cc0d3c10e9a55af6632c05be9fe8b6c6a0dbcffdb
ProcEnviron:
 SHELL=/bin/bash
 LANG=en_US.UTF-8
 LANGUAGE=en_US
 TERM=xterm-256color
 PATH=(custom, no user)Signal: 6SourcePackage: apt
StacktraceTop:
 __gnu_cxx::__verbose_terminate_handler() () from /usr/lib/x86_64-linux-gnu/libstdc++.so.6
 ?? () from /usr/lib/x86_64-linux-gnu/libstdc++.so.6
 std::terminate() () from /usr/lib/x86_64-linux-gnu/libstdc++.so.6
 __cxa_throw () from /usr/lib/x86_64-linux-gnu/libstdc++.so.6
 std::__throw_out_of_range_fmt(char const*, ...) () from /usr/lib/x86_64-linux-gnu/libstdc++.so.6
Title: apt-helper crashed with SIGABRT in __gnu_cxx::__verbose_terminate_handler()
UpgradeStatus: Upgraded to xenial on 2016-01-27 (0 days ago)
UserGroups:

StacktraceTop:
 __gnu_cxx::__verbose_terminate_handler () at ../../../../src/libstdc++-v3/libsupc++/vterminate.cc:95
 __cxxabiv1::__terminate (handler=<optimized out>) at ../../../../src/libstdc++-v3/libsupc++/eh_terminate.cc:47
 std::terminate () at ../../../../src/libstdc++-v3/libsupc++/eh_terminate.cc:57
 __cxxabiv1::__cxa_throw (obj=obj@entry=0x55865bfc6e30, tinfo=0x7fb8223b5ad8 <typeinfo for std::out_of_range>, dest=0x7fb8220e3b60 <std::out_of_range::~out_of_range()>) at ../../../../src/libstdc++-v3/libsupc++/eh_throw.cc:87
 std::__throw_out_of_range_fmt (__fmt=__fmt@entry=0x7fb822742020 "%s: __pos (which is %zu) > this->size() (which is %zu)") at ../../../../../src/libstdc++-v3/src/c++11/functexcept.cc:101

tags: removed: need-amd64-retrace
Brian Murray (brian-murray) wrote :

Do you have a url for the crash counters at errors.ubuntu.com?

Brian Murray (brian-murray) wrote :

How exactly did you install flashplugin-installer? I ran sudo apt-get install flashplugin-installer without a problem. Additionally, I've run the command line (/usr/lib/apt/apt-helper download-file http://archive.canonical.com/pool/partner/a/adobe-flashplugin/adobe-flashplugin_20151228.1.orig.tar.gz /var/lib/update-notifier/package-data-downloads/partial/adobe-flashplugin_20151228.1.orig.tar.gz SHA256:d322547d4542eeed2f57469cc0d3c10e9a55af6632c05be9fe8b6c6a0dbcffdb) after changing the destination without an issue.

Changed in apt (Ubuntu):
status: Triaged → Incomplete

Brian Murray, thanks for your inquiry.

I just uninstalled and reinstalled flashplugin-installer via apt 1.2.4 with no problem. However as per LP#1554820, they are using apt 1.2.6 and it's still reproducible.

So, this is a break-fixed-break scenario, non-deterministic, or only happens the first X time(s)/specific circumstances.

Changed in apt (Ubuntu):
status: Incomplete → Triaged
Brian Murray (brian-murray) wrote :

While that information is interesting you still didn't really answer my question. Did you install flashplugin-installer via the command line or using some other package manager?

Brian Murray, apologies for not being more verbose.

When I said I uninstalled and reinstalled it via apt 1.2.4, I meant apt-get via a terminal (not via GUI, synaptic, etc.). The commands precisely:
sudo apt-get -y remove flashplugin-installer
sudo apt-get -y install flashplugin-installer

information type: Private → Public
Brian Murray (brian-murray) wrote :

Well, I've still been unable to recreate this.

tags: added: rls-x-incoming
Changed in apt (Ubuntu):
importance: Low → High
michael jones (bcmalloy) wrote :

I have this issue, it occurred after installation - (A popup saying flash in installion had failed)
1. During the installation I had chosen to install 3rd party applications. (this includes flash)
2.Even though flash IS verified installed this error appears immediately on first boot of fresh os, it thinks the flash installation has failed.
3.It continues to happen usually during system updates

Download full text (3.4 KiB)

flashplugin is a bad plugin. HTML5 didn't use flash anymore;why there are so many flash....

------------------ 原始邮件 ------------------
发件人: "michael jones"<email address hidden>;
发送时间: 2016年3月29日(星期二) 中午11:04
收件人: "ZhangZhenkang"<email address hidden>;
主题: [Bug 1538438] Re: apt-helper crashed with SIGABRT in__gnu_cxx::__verbose_terminate_handler()

I have this issue, it occurred after installation - (A popup saying flash in installion had failed)
1. During the installation I had chosen to install 3rd party applications. (this includes flash)
2.Even though flash IS verified installed this error appears immediately on first boot of fresh os, it thinks the flash installation has failed.
3.It continues to happen usually during system updates

--
You received this bug notification because you are subscribed to a
duplicate bug report (1554820).
https://bugs.launchpad.net/bugs/1538438

Title:
  apt-helper crashed with SIGABRT in
  __gnu_cxx::__verbose_terminate_handler()

Status in apt package in Ubuntu:
  Triaged

Bug description:
  After installing flashplugin-installer I get a prompt noting:
  [START]
  Failure to download extra data files

  The following packages requested additional data downloads after
  package installation, but the data could not be downloaded or could
  not be processed.

  flashplugin-installer

  The download will be attempted again later, or you can try the download again now. Running this command requires an active Internet connection.
  [END]

  Clicking the button Run this action now causes this crash
  consistently.

  Unfortunately, this has the negative outcome of disallowing folks who
  use Firefox from being able to update, or install Flash.

  There are a fair number of these events logged in errors.ubuntu.com.

  WORKAROUND: Use Google Chrome/Chromium with pepper flash.

  ProblemType: Crash
  DistroRelease: Ubuntu 16.04
  Package: apt 1.1.10
  ProcVersionSignature: Ubuntu 4.3.0-7.18-generic 4.3.3
  Uname: Linux 4.3.0-7-generic x86_64
  ApportVersion: 2.19.4-0ubuntu1
  Architecture: amd64
  Date: Wed Jan 27 01:36:34 2016
  ExecutablePath: /usr/lib/apt/apt-helper
  InstallationDate: Installed on 2015-04-25 (276 days ago)
  InstallationMedia: Ubuntu 15.04 "Vivid Vervet" - Release amd64 (20150422)
  ProcCmdline: /usr/lib/apt/apt-helper download-file http://archive.canonical.com/pool/partner/a/adobe-flashplugin/adobe-flashplugin_20151228.1.orig.tar.gz /var/lib/update-notifier/package-data-downloads/partial/adobe-flashplugin_20151228.1.orig.tar.gz SHA256:d322547d4542eeed2f57469cc0d3c10e9a55af6632c05be9fe8b6c6a0dbcffdb
  ProcEnviron:
   SHELL=/bin/bash
   LANG=en_US.UTF-8
   LANGUAGE=en_US
   TERM=xterm-256color
   PATH=(custom, no user)
  Signal: 6
  SourcePackage: apt
  StacktraceTop:
   __gnu_cxx::__verbose_terminate_handler() () from /usr/lib/x86_64-linux-gnu/libstdc++.so.6
   ?? () from /usr/lib/x86_64-linux-gnu/libstdc++.so.6
   std::terminate() () from /usr/lib/x86_64-linux-gnu/libstdc++.so.6
   __cxa_throw () from /usr/lib/x86_64-linux-gnu/libstdc++.so.6
   std::__throw_out_of_range_fmt(char const*, ...) () from /usr/lib/x8...

Read more...

Changed in apt (Ubuntu):
milestone: none → xenial-updates
description: updated
tags: added: yakkety
Marcus (ma-wilkinson) wrote :
Download full text (8.3 KiB)

I've the same problem - after upgrading to 16.04 xenial I get the same pop-up window.

Failure to download extra data files

The following packages requested additional data downloads after package installation, but the data could not be downloaded or could not be processed.

lovefilm-desktop, wine-browser-installer, wine-silverlight5.1-installer

The download will be attempted again later, or you can try the download again now. Running this command requires an active Internet connection.

[x64 stacktrace]
SourcePackage: apt
Stacktrace:
 #0 0x00007fb73069f418 in __GI_raise (sig=sig@entry=6) at ../sysdeps/unix/sysv/linux/raise.c:54
         resultvar = 0
         pid = 8080
         selftid = 8080
 #1 0x00007fb7306a101a in __GI_abort () at abort.c:89
         save_stage = 2
         act = {__sigaction_handler = {sa_handler = 0x0, sa_sigaction = 0x0}, sa_mask = {__val = {0, 140424771724608, 140424768269103, 140424771724608, 1, 10, 140424768784912, 10, 140424771729264, 140424785635104, 140424768784912, 1, 140424785637456, 93987686793024, 140424771729264, 140424785635136}}, sa_flags = 818763904, sa_restorer = 0x557b36af9dc8}
         sigs = {__val = {32, 0 <repeats 15 times>}}
 #2 0x00007fb730cd884d in __gnu_cxx::__verbose_terminate_handler() () from /usr/lib/x86_64-linux-gnu/libstdc++.so.6
 No symbol table info available.
 #3 0x00007fb730cd66b6 in ?? () from /usr/lib/x86_64-linux-gnu/libstdc++.so.6
 No symbol table info available.
 #4 0x00007fb730cd6701 in std::terminate() () from /usr/lib/x86_64-linux-gnu/libstdc++.so.6
 No symbol table info available.
 #5 0x00007fb730cd6919 in __cxa_throw () from /usr/lib/x86_64-linux-gnu/libstdc++.so.6
 No symbol table info available.
 #6 0x00007fb730cff3e7 in std::__throw_out_of_range_fmt(char const*, ...) () from /usr/lib/x86_64-linux-gnu/libstdc++.so.6
 No symbol table info available.
 #7 0x00007fb731282546 in pkgAcquire::Worker::RunMessages() () from /usr/lib/x86_64-linux-gnu/libapt-pkg.so.5.0
 No symbol table info available.
 #8 0x00007fb731282c9c in pkgAcquire::Worker::InFdReady() () from /usr/lib/x86_64-linux-gnu/libapt-pkg.so.5.0
 No symbol table info available.
 #9 0x00007fb73128430a in pkgAcquire::RunFdsSane(fd_set*, fd_set*) () from /usr/lib/x86_64-linux-gnu/libapt-pkg.so.5.0
 No symbol table info available.
 #10 0x00007fb731287b52 in pkgAcquire::Run(int) () from /usr/lib/x86_64-linux-gnu/libapt-pkg.so.5.0
 No symbol table info available.
 #11 0x00007fb730fe5503 in AcquireRun(pkgAcquire&, int, bool*, bool*) () from /usr/lib/x86_64-linux-gnu/libapt-private.so.0.0
 No symbol table info available.
 #12 0x0000557b349c7c06 in ?? ()
 No symbol table info available.
 #13 0x00007fb7312b17a6 in CommandLine::DispatchArg(CommandLine::Dispatch const*, bool) () from /usr/lib/x86_64-linux-gnu/libapt-pkg.so.5.0
 No symbol table info available.
 #14 0x00007fb730fe0df3 in DispatchCommandLine(CommandLine&, std::vector<CommandLine::Dispatch, std::allocator<CommandLine::Dispatch> > const&) () from /usr/lib/x86_64-linux-gnu/libapt-private.so.0.0
 No symbol table info available.
 #15 0x0000557b349c665c in ?? ()
 No symbol table info available.
 #16 0x00007fb73068a830 in __libc_start_main (main=0x557b349c65d0,...

Read more...

David Kalnischkies (donkult) wrote :

Could be: https://anonscm.debian.org/cgit/apt/apt.git/commit/?id=84ac6edfabe1c92d67e8d441e04216ad33c89165
Which is a problem with the redirection handling, which would also explain why its not happening for everyone as these download servers might be doing (no) redirections based on the region of the requester.

At least that break fits in the timeframe, is in mentioned method (RunMessages) and happens [only] with apt-helper (see added test), but I use none of those downloader packages and don't feel like starting to, so that is just an educated guess.

Brian Murray (brian-murray) wrote :

If this crash is fixed by the commit to which David pointed, then that is fixed in version 1.2.12 of apt which is now in Debian. Rather than waiting to see if that version does not appear in the errors bucket, keeping in mind there are only a handful of crashes about 1.2.11, I think we should upload the fix to -proposed for Xenial and see what happens.

Changed in apt (Ubuntu):
assignee: nobody → Brian Murray (brian-murray)
Changed in apt (Ubuntu Xenial):
status: New → In Progress
importance: Undecided → High
assignee: nobody → Brian Murray (brian-murray)
Changed in apt (Ubuntu):
assignee: Brian Murray (brian-murray) → nobody
milestone: xenial-updates → none
description: updated

Hello Christopher, or anyone else affected,

Accepted apt into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/apt/1.2.12~ubuntu16.04.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in apt (Ubuntu Xenial):
status: In Progress → Fix Committed
tags: added: verification-needed

Martin Pitt, thanks for working on this. I've utilized the non-Proposed release and this worked fine. However, I'll leave it to others to certify this is passed/failed as the issue appears environment or timing specific.

sudo apt -y install flashplugin-installer
Reading package lists... Done
Building dependency tree
Reading state information... Done
Suggested packages:
  x-ttcidfont-conf ttf-bitstream-vera | ttf-dejavu ttf-xfree86-nonfree
  xfs
The following NEW packages will be installed:
  flashplugin-installer
0 upgraded, 1 newly installed, 0 to remove and 0 not upgraded.
Need to get 0 B/6,838 B of archives.
After this operation, 58.4 kB of additional disk space will be used.
Preconfiguring packages ...
Selecting previously unselected package flashplugin-installer.
(Reading database ... 280227 files and directories currently installed.)
Preparing to unpack .../flashplugin-installer_11.2.202.621ubuntu0.16.04.1_amd64.deb ...
Unpacking flashplugin-installer (11.2.202.621ubuntu0.16.04.1) ...
Processing triggers for update-notifier-common (3.168) ...
flashplugin-installer: downloading http://archive.canonical.com/pool/partner/a/adobe-flashplugin/adobe-flashplugin_20160512.1.orig.tar.gz
Get:1 http://archive.canonical.com/pool/partner/a/adobe-flashplugin/adobe-flashplugin_20160512.1.orig.tar.gz [27.1 MB]
Fetched 27.1 MB in 1min 14s (362 kB/s)
W: Can't drop privileges for downloading as file '/var/lib/update-notifier/package-data-downloads/partial/adobe-flashplugin_20160512.1.orig.tar.gz' couldn't be accessed by user '_apt'. - pkgAcquire::Run (13: Permission denied)
Installing from local file /var/lib/update-notifier/package-data-downloads/partial/adobe-flashplugin_20160512.1.orig.tar.gz
Flash Plugin installed.
Setting up flashplugin-installer (11.2.202.621ubuntu0.16.04.1) ...

apt-cache policy apt
apt:
  Installed: 1.2.10ubuntu1
  Candidate: 1.2.10ubuntu1
  Version table:
 *** 1.2.10ubuntu1 500
        500 http://us.archive.ubuntu.com/ubuntu xenial/main amd64 Packages
        100 /var/lib/dpkg/status

Julian Andres Klode (juliank) wrote :

The linked commit was included in 1.3~exp1 in yakkety

Changed in apt (Ubuntu):
status: Triaged → Fix Released
Martin Pitt (pitti) wrote :

The above errors bucket has no versions > 1.2.10, so it at least did not happen for any user of xenial-proposed.

tags: added: verification-done
removed: verification-needed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package apt - 1.2.12~ubuntu16.04.1

---------------
apt (1.2.12~ubuntu16.04.1) xenial; urgency=medium

  * Upload 1.2.12 micro-release to Xenial (LP: #1538438, #1580952)

apt (1.2.12) unstable; urgency=medium

  [ Patrick Cable ]
  * refactored no_proxy code to work regardless of where https proxy is set

  [ James McCoy ]
  * deb822: Restore support for <multivalue>-{Add,Remove}

  [ David Kalnischkies ]
  * don't show NO_PUBKEY warning if repo is signed by another key
    (Closes: 618445)
  * allow redirection for items without a space in the desc again
  * don't sent uninstallable rc-only versions via EDSP
  * respect user pinning in M-A:same version (un)screwing

  [ Julian Andres Klode ]
  * update: Run Post-Invoke-Success if not all sources failed
  * debian/gbp.conf: Set debian-branch to 1.2.y

  [ Frans Spiesschaert ]
  * Dutch program translation update (Closes: 823976)

apt (1.2.11) unstable; urgency=medium

  [ David Kalnischkies ]
  * ensure transaction states are changed only once
  * stop handling items in doomed transactions.
    Thanks to Barr Detwix & Vincent Lefevre for log files (Closes: 817240)
  * do not require non-broken systems in 'upgrade'
  * detect compressed status files on extension again
  * recheck Pre-Depends satisfaction in SmartConfigure (LP: #1569099)
  * fix Alt-Filename handling of file method
  * allow uncompressed files to be empty in store again
  * silently skip acquire of empty index files
  * ensure outdated files are dropped without lists-cleanup

  [ Kelemen Gábor ]
  * Hungarian program translation update (Closes: 820638)

 -- Adam Conrad <email address hidden> Thu, 12 May 2016 04:08:00 -0600

Changed in apt (Ubuntu Xenial):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for apt has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers